#include "defs.h"

/*
 *  Check for and act on any output to be displayed.
 *
 *  <LH:881125:v2.0>
 */

void
add_his_window (c)
register c;
{
	register WINDOW *win = hiswin;

	switch (c)
	{
		case  DISCONNECT:
			disconnect (HE_DISCONNECTED);
			/*NOTREACED*/

		case  DELETE  :
			wprevch (win);
			wdelch (win);
			break;

		case  BELL  :
			beep();
			break;

		default  :
			if (printable (c))
				waddch (win, c);
			break;
	}

        wnoutrefresh (win);

}


/*
 *  Check for and act on user input
 *
 *  <LH:881125:v2.0>
 */

void
add_my_window(c)
register c;
{
	register WINDOW *win = mywin;

	switch (c)
	{
		case  END_OF_FILE:
			disconnect (I_DISCONNECTED);
			/*NOTREACED*/

		case  REFRESH:
			clearok (curscr, TRUE);
			break;

		case  BELL:
			beep();
			break;

		case DELETE:
			wprevch (win);
			wdelch (win);
			break;

		default  :
			if (printable (c))
				waddch (win, c);
			else
			{
				beep();
				return;
			}
			break;
	}
        wnoutrefresh (win);
	sendmsg (hispid, c);	/* send character to other side */
}


/*
 *  Print message at head of window
 */

void
wheader (win, message)
register WINDOW	*win;
char	*message;
{
	wmove (win, 0, 0);
	wclrtoeol (win);
	waddstr (win, message);
}


/*
 *  Initialise talk windows
 */

void
screen_init()
{
        int	i;

        initscr();

        mywin = newwin (MY_WINLINES, COLS, 0, 0);
        hiswin = newwin (HIS_WINLINES, COLS, MY_WINLINES + 1, 0);
        dividewin = newwin (1, COLS, MY_WINLINES, 0);


	noecho ();
	cbreak ();
        scrollok (mywin, TRUE);
        scrollok (hiswin, TRUE);
	idlok (mywin, TRUE);
	idlok (hiswin, TRUE);


        wmove (dividewin, 0, 0);

        for (i = 0 ; i < COLS ; i++)
                waddch (dividewin, '-');

	/* faster screen update (a la curses manual) */

        wnoutrefresh (mywin);
        wnoutrefresh (hiswin);
        wnoutrefresh (dividewin);
}



/*
 *  Move cursor back to previous non-space char within window
 */

void
wprevch (win)
register WINDOW	*win;
{
	register x, y;

	getyx (win, y, x);

	if (--x < 0)   {
		if (--y < 0)   {
			wmove (win, 0, 0);
			return;
		}
		for (x = win->_maxx - 1 ; x >= 0 ; --x)
		{
			wmove(win, y, x);

			if (winch(win) != ' ')
				return;
		}
		return;
	}
	wmove (win, y, x);
}
